#include<iostream>
#include<vector>
#include<string>
#include<boost/graph/adjacency_list.hpp>
#include<boost/tuple/tuple.hpp>

enum family { Jeanie, Debbie, Rick, John, Amanda, Margaret, Benjamin, N };

int main(int argc, char ** argv) {

  using namespace boost;

  const char * name[] = { "Jeanie", "Debbie", "Rick", "John", "Amanda", "Margaret", "Benjamin" };

  adjacency_list<> g(N);
  add_edge(Jeanie, Debbie, g);
  add_edge(Jeanie, Rick, g);
  add_edge(Jeanie, John, g);
  add_edge(Debbie, Amanda, g);
  add_edge(Rick, Margaret, g);
  add_edge(John, Benjamin, g);

  graph_traits < adjacency_list <> >::vertex_iterator i, end;
  graph_traits < adjacency_list <> >::adjacency_iterator a_i, a_end;
  property_map < adjacency_list <>, vertex_index_t >::type index_map = get(vertex_index, g);

  for(tie(i, end) = vertices(g); i != end; ++i) {
    std::cout << name[get(index_map, *i)];
    tie(a_i, a_end) = adjacent_vertices(*i, g);
    if(a_i == a_end) std::cout << " has no children";
    else std::cout << " is the parent of ";
    for(; a_i != a_end; ++a_i) {
      std::cout << name[get(index_map, *a_i)];
      if(boost::next(a_i) != a_end) std::cout << ", ";
    }
    std::cout << std::endl;
  }

  return EXIT_SUCCESS;
}
